#include <fcntl.h>  
#include "xcamac.h"
#include "camlib.h"

static int cam_fd;

struct camac_single{
  unsigned int naf;
  unsigned int data;
  unsigned int qx;
};

struct camac_block_l{
  unsigned int naf;
  unsigned int mode;
  unsigned int ch;
  //unsigned int data[512];
  unsigned int *data;
  unsigned int retlen;
};

struct camac_block_w{
  unsigned int naf;
  unsigned int mode;
  unsigned int ch;
  //unsigned short data[512];
  //unsigned short *data;
  int *data;
  unsigned int retlen;
};

struct camac_block{
  unsigned int naf;
  unsigned int mode;
  unsigned int ch;
  void *data;
  unsigned int retlen;
};

int camopen(void)
{
  if((cam_fd = open("/dev/xcamac", O_RDWR)) == -1)
    return -1;

  return 0;
}

int camcls(void)
{
  if( close(cam_fd) != 0 )
    return -1;

  return 0;
}

int naf(int n, int a, int f)
{
  return ((n<<9)+(a<<5)+f);
}

int cgenz()
{
  struct camac_single cam_sing;
  
  cam_sing.naf  = naf(30, 0, 1);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;

  cam_sing.data |= 0x1;
  cam_sing.naf  = naf(30, 0, 17);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;

  return 0;
}

int cgenc()
{
  struct camac_single cam_sing;
  
  cam_sing.naf  = naf(30, 0, 1);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;

  cam_sing.data |= 0x2;
  cam_sing.naf  = naf(30, 0, 17);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;

  return 0;
}

int cseti()
{
  struct camac_single cam_sing;
  
  cam_sing.naf  = naf(30, 0, 1);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;

  cam_sing.data |= 0x4;
  cam_sing.naf  = naf(30, 0, 17);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;

  return 0;
}

int cremi()
{
  struct camac_single cam_sing;
  
  cam_sing.naf  = naf(30, 0, 1);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;

  cam_sing.data &= ~0x4;
  cam_sing.naf  = naf(30, 0, 17);
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;
  
  return 0;
}

int camac(int naf, int *data, int *q, int *x)
{
  struct camac_single cam_sing;
  
  cam_sing.data = *data;
  cam_sing.naf  = naf;
 
  if(ioctl(cam_fd, CAMACL, &cam_sing) == -1)
    return -1;
  
  *q = (cam_sing.qx >> 1);
  *x = (cam_sing.qx && 1);
  *data = cam_sing.data;

  return 0; 
}

int camacw(int naf, int *data, int *q, int *x)
{
  struct camac_single cam_sing;
  
  cam_sing.data = *data;
  cam_sing.naf  = naf;
 
  if(ioctl(cam_fd, CAMACW, &cam_sing) == -1)
    return -1;
  
  *q = (cam_sing.qx >> 1);
  *x = (cam_sing.qx && 1);
  *data = cam_sing.data;

  return 0; 
}

int cdma(int mode, int naf, int *buf, int len, int *retlen)
{
  int i;
  struct camac_block_l cam_blk;

  cam_blk.naf      = naf;
  cam_blk.mode     = mode + LONG + FAST;
  cam_blk.ch       = len;
  cam_blk.data     = buf;

  if(ioctl(cam_fd, BLOCKL, &cam_blk) == -1)
    return -1;

  *retlen = cam_blk.retlen;
  //for(i = 0; i < len; i++)
  //buf[i] = cam_blk.data[i];

  return 0;
}

//int cdmaw(int mode, int naf, unsigned short *buf, int len, int *retlen)
int cdmaw(int mode, int naf, int *buf, int len, int *retlen)
{
  int i;
  struct camac_block_w cam_blk;

  cam_blk.naf      = naf;
  cam_blk.mode     = mode + WORD + FAST;
  cam_blk.ch       = len;
  (int *)cam_blk.data     = buf;
  if(ioctl(cam_fd, BLOCKW, &cam_blk) == -1)
    return -1;

  *retlen = cam_blk.retlen;
  //for(i = 0; i < len; i++)
  //buf[i] = cam_blk.data[i];

  return 0;
}

